<!-- This web page was generated by Eleven, a programming language for creating bulletproof,
     scalable web applications. See http://eleven.sourceforge.net for more information. -->

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<?php

#----------------------------------------------------------------------
# Universal handler for all Eleven-generated PHP web pages
#----------------------------------------------------------------------

function runtime11_handler ($db_connect, $db_user, $db_pass, $package_name, $auth_method, $schema_id)
{
  # Get database connection parameters.

  list ($method, $driver, $db_info) = explode (":", $db_connect);
  list ($db_name_info, $db_host_info) = explode (";", $db_info);
  list ($discard, $db_name) = explode ("=", $db_name_info);
  list ($discard, $db_host) = explode ("=", $db_host_info);

  # Connect to database.

  $dbh = mysql_connect($db_host, $db_user, $db_pass);
  if (! $dbh)
  {
    generate_display_missing_state ("Failed to connect to database host \"$db_host\".");
    return;
  }

  if (! mysql_select_db ($db_name))
  {
    generate_display_missing_state ("Failed to open connection to database \"$db_name\".");
    return;
  }

  # Read POST parameters, and merge in continuation id from query string.

  $parameters = $_POST;
  if (isset ($_GET ['cid']))
  {
    $parameters ['cid'] = $_GET ['cid'];
  }

  # Check for magic quotes. If they are enabled, our parameters have
  # already been escaped. Undo the damage:

  if (get_magic_quotes_gpc ())
  {
    foreach (array_keys ($parameters) as $k)
    {
      $parameters [$k] = stripslashes ($parameters [$k]);
    }
  }

  # Check if the logout button was pressed. If so, start a new session.
  # Make sure to invalidate any cached web pages by marking all of the
  # user's other continuations as deleted.

  if (isset ($parameters ['action']) and ($parameters ['action'] === 'Logout'))
    {
	$state = db_read_continuation ($dbh, $parameters ['cid'], 0);
	if (! $state)
	{
	    start_session ($dbh, "User logout. (warning: missing session information)", $package_name, $auth_method, $schema_id);
	}
	else
	{
	    if ($parameters ['authtoken'] !== $state ['auth_token'])
	    {
		start_session ($dbh, "User logout. (warning: invalid session information)", $package_name, $auth_method, $schema_id);
	    }
	    else
	    {
		$parent_uid = $state ['parent_uid'];
		if ($parent_uid != 0)
		{
		    $next_state = $state; 
		    
		    display_state_update ($next_state, $next_state ['display_state']);

		    $next_state ['predecessor_cid'] = $state ['cid'];
		    $next_state ['back_flag'] = ($state ['next_cid'] ? 1 : 0);

		    db_insert_continuation ($dbh, $next_state);
		    db_update_user ($dbh, $parent_uid, $next_state ['cid']);
		    db_remove_user_continuations_except ($dbh, $parent_uid, $next_state ['cid']);
		}
		start_session ($dbh, "User logout.", $package_name, $auth_method, $schema_id);
	    }
	}
    }
    else
    {
	# If we got to this point, then the logout button was not pressed. Check if the query
        # string contains a valid continuation ID.

	$state = db_read_continuation ($dbh, (isset ($parameters ['cid']) ? $parameters ['cid'] : NULL), 0);
	if (! $state)
	{
	    # No valid continuation ID found. Either the user's session expired or this is a
	    # fresh login.  In either case, start a new session.
	    
	    start_session ($dbh, (isset ($parameters ['cid']) ? "Session has expired." : "Starting new session."), $package_name, $auth_method, $schema_id);
	}
	else
	{
	    # Continuation found. Check the authorization token to see if it's valid. If not,
	    # start a new session. If so, check the schema id to see whether the continuation
	    # was created by this version of the application. If not, start a new
	    # session. Otherwise, resume the application based on the information in the
	    # continuation.

	    if ($parameters ['authtoken'] !== $state ['auth_token'])
	    {
		start_session ($dbh, "Forced logout due to invalid attempt to connect to session.", $package_name, $auth_method, $schema_id);
	    }
	    else
	    {
		if ($state ['schema_id'] !== $schema_id)
		{
		    start_session ($dbh, "Forced logout due to system upgrade.", $package_name, $auth_method, $schema_id);
		}
		else
		{
		    continue_session ($dbh, $parameters, $state);
		}
	    }
	}
    }

    # Disconnect from database.

    mysql_close ($dbh);
}

#----------------------------------------------------------------------
# Get IP address and port number of HTTP client
#----------------------------------------------------------------------

function get_remote_addr ()
{
    return array ($_SERVER['REMOTE_ADDR'], $_SERVER['REMOTE_PORT']);
}

#----------------------------------------------------------------------
# Generate a unique continuation ID
#----------------------------------------------------------------------

function gen_cid ()
{
  static $cid_counter = 0;

  # To generate a unique continuation ID, we use the IP address and port number of the client
  # and a one-second resolution timestamp. That gives us uniqueness unless the client somehow
  # generated more than one request per second from the same outgoing port number.
  # 
  # In the unlikely case that's a problem, we add in the process ID of the web server and a
  # unique counter per server. Also for good measure, we also generate three random numbers
  # between 0 and 999,999 and throw those in too.

  list ($remote_addr, $remote_port) = get_remote_addr ();
  list ($a, $b, $c, $d) = explode (".", $remote_addr, 4);
  $packed_addr = $a * 256 * 256 * 256 + $b * 256 * 256 + $c * 256 + $d;

  $cid = sprintf ("%010u-%06u-%010u-%06u-%06u-%06u-%06u-%06u",
		  $packed_addr,
		  $remote_port,
		  time (),
		  posix_getpid (),
		  $cid_counter,
		  rand (0, 999999),
		  rand (0, 999999),
		  rand (0, 999999));
  
  $cid_counter ++;
  if ($cid_counter > 999999)
    {
      $cid_counter = 0;
    }

  return $cid;
}

#----------------------------------------------------------------------
# Generate a unique row ID
#----------------------------------------------------------------------

function gen_rowid ()
{
  static $rowid_counter = 0;

  # To generate a unique row ID, we do the same thing as for continuation IDs.

  list ($remote_addr, $remote_port) = get_remote_addr ();
  list ($a, $b, $c, $d) = explode (".", $remote_addr, 4);
  $packed_addr = $a * 256 * 256 * 256 + $b * 256 * 256 + $c * 256 + $d;

  $rowid = sprintf ("%010u-%06u-%010u-%06u-%06u-%06u-%06u-%06u",
		  $packed_addr,
		  $remote_port,
		  time (),
		  posix_getpid (),
		  $rowid_counter,
		  rand (0, 999999),
		  rand (0, 999999),
		  rand (0, 999999));
  
  $rowid_counter ++;
  if ($rowid_counter > 999999)
    {
      $rowid_counter = 0;
    }

  return $rowid;
}

#----------------------------------------------------------------------
# Generate an authorization token. These are stored in hidden fields on
# each web page, and checked to make sure the URL wasn't cut and pasted
# or bookmarked.
#----------------------------------------------------------------------

function gen_auth_token ()
{
  return sprintf ("%08u%08u", rand (0, 99999999), rand (0, 99999999));
}

#----------------------------------------------------------------------
# Generate a timestamp
#----------------------------------------------------------------------

function gen_timestamp ()
{
  $ts = strftime ("%Y-%m-%d %H:%M:%S", time ());
  return $ts;
}

#----------------------------------------------------------------------
# Get the maximum index for a subarray within the "vars" array
#----------------------------------------------------------------------

function var_array_max_index (&$a)
{
  if (! is_array ($a))
    {
      return -1;
    }

  if (count ($a) == 0)
    {
      return -1;
    }

  return max (array_keys ($a));
}

#----------------------------------------------------------------------
# Read all data associated with a particular continuation
#----------------------------------------------------------------------

function db_read_continuation ($dbh, $cid, $ignore_deleted_flag)
{
    if (! $cid)
    {
      return NULL;
    }

    $state = array ();

    $sth = mysql_query ($ignore_deleted_flag ? "SELECT * FROM continuation WHERE cid = '$cid'"
			                     : "SELECT * FROM continuation WHERE deleted_flag = 0 AND cid = '$cid'", $dbh);

    $rowcount = 0;
    while ($ref = mysql_fetch_assoc ($sth))
      {
	$state ['cid']             = $ref ['cid'];
 	$state ['auth_token']      = $ref ['auth_token'];
 	$state ['creation_time']   = $ref ['creation_time'];
	$state ['parent_uid']      = $ref ['parent_uid'];
	$state ['display_state']   = $ref ['display_state'];
	$state ['schema_id']       = $ref ['schema_id'];
	$state ['next_cid']        = $ref ['next_cid'];
	$state ['predecessor_cid'] = $ref ['predecessor_cid'];
	$state ['back_flag']       = $ref ['back_flag'];
	$state ['deleted_flag']    = $ref ['deleted_flag'];
	$rowcount ++;
      }

    mysql_free_result ($sth);

    if ($rowcount != 1)
    {
	return NULL;
    }

    # If we got to this point, then a valid continuation was found
    # (and was not deleted), therefore the corresponding continuation
    # data is valid and we can go ahead and read it.

    $sth = mysql_query ("SELECT * FROM continuation_data WHERE parent_cid = '$cid'", $dbh);

    while ($ref = mysql_fetch_assoc ($sth))
    {
	$state ['vars'] [$ref ['stack_frame']] [$ref ['variable']] [$ref ['variable_index']] = $ref ['value'];
    }

    mysql_free_result ($sth);
    return $state;
}

#----------------------------------------------------------------------
# Write all data associated with a particular continuation
#----------------------------------------------------------------------

function db_insert_continuation ($dbh, &$state)
{
    $sth = mysql_query ("INSERT INTO continuation (cid, auth_token, creation_time, parent_uid, display_state, schema_id, next_cid, predecessor_cid, back_flag) VALUES ('"
			. $state ['cid'] . "', '"
			. $state ['auth_token'] . "', '"
			. $state ['creation_time'] . "', '"
			. $state ['parent_uid'] . "', '"
			. $state ['display_state'] . "', '"
			. $state ['schema_id'] . "', '"
			. $state ['next_cid'] . "', '"
			. $state ['predecessor_cid'] . "', '"
			. $state ['back_flag'] . "')", $dbh);

    if (! $sth)
      {
	return NULL;
      }

    for ($stack_frame = 0; $stack_frame <= var_array_max_index ($state ['vars']); $stack_frame++)
      {
	for ($variable = 0; $variable <= var_array_max_index ($state ['vars'] [$stack_frame]); $variable++)
	  {
	    for ($variable_index = 0; $variable_index <= var_array_max_index ($state ['vars'] [$stack_frame] [$variable]); $variable_index++)
	      {
		$sth = mysql_query ("INSERT INTO continuation_data (parent_cid, stack_frame, variable, variable_index, value) VALUES ('" .
				    $state ['cid'] . "', '$stack_frame', '$variable', '$variable_index', '" . addslashes ($state ['vars'] [$stack_frame] [$variable] [$variable_index]) . "')", $dbh);
	      }
	  }
      }
}

#----------------------------------------------------------------------
# Update the "next_cid" flag of a continuation
#----------------------------------------------------------------------

function db_update_continuation ($dbh, &$state)
{
    # Don't bother checking deleted_flag, since:
    # (a) this operation should never be invoked on a deleted continuation, and
    # (b) even if it is invoked on a deleted continuation, so what?

    $sth = mysql_query ("UPDATE continuation SET next_cid = '" . $state ['next_cid'] . "' WHERE cid = '" . $state ['cid'] . "'", $dbh);
}

#----------------------------------------------------------------------
# Remove all continuations that are marked as successors of this one
#----------------------------------------------------------------------

function db_remove_successor_continuations ($dbh, &$state)
{
  $cid = $state ['next_cid'];

  while ($cid)
  {
    $next_cid = NULL;

    # Don't bother checking deleted_flag, since:
    # (a) this operation should never be invoked on a deleted continuation, and
    # (b) even if it is invoked on a deleted continuation, so what?

    $sth = mysql_query ("SELECT next_cid FROM continuation WHERE cid = '$cid'", $dbh);
    while ($ref = mysql_fetch_assoc ($sth))
    {
	$next_cid = $ref ['next_cid'];
    }
    mysql_free_result ($sth);

    $sth = mysql_query ("UPDATE continuation SET deleted_flag = 1 WHERE cid = '$cid'", $dbh);
    
    $cid = $next_cid;
  }
}

#------------------------------------------------------------
# Remove all continuations for a particular user except for
# a single specified one.
#------------------------------------------------------------

function db_remove_user_continuations_except ($dbh, $uid, $keep_cid)
{
  $sth = mysql_query ("UPDATE continuation SET deleted_flag = 1 WHERE parent_uid = '$uid' AND cid <> '$keep_cid'", $dbh);
}

#----------------------------------------------------------------------
# Read user data for authentication
#----------------------------------------------------------------------

function db_read_user ($dbh, $package_name, $login, $password)
{
    $sth = mysql_query ("SELECT * FROM user WHERE package = '$package_name' AND auto_created_flag = 0 AND login = '$login' AND password = MD5('$password')", $dbh);

    $name = NULL;
    $uid = NULL;
    $current_cid = NULL;

    while ($ref = mysql_fetch_assoc ($sth))
    {
      $name = $ref ['name'];
      $uid = $ref ['uid'];
      $current_cid = $ref ['current_cid'];
    }

    mysql_free_result ($sth);

    return array ($name, $uid, $current_cid);
}

#----------------------------------------------------------------------
# Update a user's current continuation
#----------------------------------------------------------------------

function db_update_user ($dbh, $uid, $cid)
{
  if ($uid and $cid)
    {
      $sth = mysql_query ("UPDATE user SET current_cid = '$cid' WHERE uid = '$uid'", $dbh);
    }
}

#----------------------------------------------------------------------
# Start a session
#----------------------------------------------------------------------

function start_session ($dbh, $status_message, $package_name, $auth_method, $schema_id)
{
  if ($auth_method === 'auto')
    {
      # If authentication method is "auto", then every new session should automatically
      # generate a fresh uid:

      $new_uid = rand (0, 99999999);
      $sth = mysql_query ("INSERT INTO user (package, creation_time, auto_created_flag, uid) VALUES ('$package_name', NOW(), 1, '$new_uid')", $dbh);

      # Now start the session. Initialize state with the new uid. Set display number to 2,
      # which is always the "program termination" display.  That display is immediately
      # followed by a jump to "main" (the beginning of the user program code), so call the
      # "execute" function to make the jump happen and run the user program code until the
      # first display. Then save the continuation.
      # 
      # In the future it might be cleaner to allocate a special display number that means
      # "jump to main".

      $tmp_parameters = array ();

      $tmp_state = array ('cid' => gen_cid (),
			  'auth_token' => gen_auth_token (),
			  'creation_time' => gen_timestamp (),
			  'parent_uid' => $new_uid,
			  'display_state' => 2,
			  'schema_id' => $schema_id,
			  'next_cid' => NULL,
			  'predecessor_cid' => NULL,
			  'back_flag' => 0 );

	$state = execute_program ($dbh, $tmp_parameters, $tmp_state);
    }
    else
    {
	# For any other authentication method, jump to screen zero, which is always some sort of
	# login screeen. No need to run any user program code at this point.
        $state = array ('cid' => gen_cid (),
		        'auth_token' => gen_auth_token (),
		       'creation_time' => gen_timestamp (),
		       'parent_uid'      => 0,
		       'display_state'   => 0,
		       'schema_id'       => $schema_id,
		       'next_cid'        => NULL,
		       'predecessor_cid' => NULL,
		       'back_flag'       => 0 );

    }

    db_insert_continuation ($dbh, $state); 
    generate_display ($status_message, $state);
}

#----------------------------------------------------------------------
# Resume a session
#----------------------------------------------------------------------

function continue_session ($dbh, &$parameters, &$state)
{
    $next_state = execute_program ($dbh, $parameters, $state);

    $next_state ['predecessor_cid'] = $state ['cid'];
    $next_state ['back_flag'] = ($state ['next_cid'] ? 1 : 0);

    db_insert_continuation ($dbh, $next_state);

    if ($next_state ['parent_uid'] != 0)
    {
	db_update_user ($dbh, $next_state ['parent_uid'], $next_state ['cid']);

	if ($next_state ['resumed_session'] === 'yes')
	{
	    db_remove_user_continuations_except ($dbh, $next_state ['parent_uid'], $next_state ['cid']);
	    generate_display ("Resuming session for user " . $next_state ['parent_uid'] . ".", $next_state);
	}
	elseif ($next_state ['resumed_session'] === 'schema_reset')
	{
	    db_remove_user_continuations_except ($dbh, $next_state ['parent_uid'], $next_state ['cid']);
	    generate_display ("Session restarted due to system upgrade.", $next_state);
	}
	else
	{
	    db_remove_successor_continuations ($dbh, $state);
	    $state ['next_cid'] = $next_state ['cid'];
	    db_update_continuation ($dbh, $state);
	    generate_display ("Updated state for user " . $next_state ['parent_uid'] . ".", $next_state);
	}
    }
    else
    {
      generate_display ("No user logged in.", $next_state);
    }
}

#----------------------------------------------------------------------
# Functions to manipulate the "vars" array
#----------------------------------------------------------------------

function var_delete (&$state, $stack_frame, $variable)
{
  if (! isset ($state ['vars']))
    return;

  if (! isset ($state ['vars'] [$stack_frame]))
    return;

  if (! isset ($state ['vars'] [$stack_frame] [$variable]))
    return;

  unset ($state ['vars'] [$stack_frame] [$variable]);
  return;
}

function var_scalar_read (&$state, $stack_frame, $variable)
{
  if (! isset ($state ['vars']))
    return NULL;

  if (! isset ($state ['vars'] [$stack_frame]))
    return NULL;

  if (! isset ($state ['vars'] [$stack_frame] [$variable]))
    return NULL;

  if (! isset ($state ['vars'] [$stack_frame] [$variable] [0]))
    return NULL;

  return $state ['vars'] [$stack_frame] [$variable] [0];
}

function var_scalar_write (&$state, $stack_frame, $variable, $value)
{
  $state ['vars'] [$stack_frame] [$variable] [0] = $value;
}

function var_scalar_delete (&$state, $stack_frame, $variable)
{
  if (! isset ($state ['vars']))
    return;

  if (! isset ($state ['vars'] [$stack_frame]))
    return;

  if (! isset ($state ['vars'] [$stack_frame] [$variable]))
    return;

  if (! isset ($state ['vars'] [$stack_frame] [$variable] [0]))
    return;

  unset ($state ['vars'] [$stack_frame] [$variable] [0]);
  return;
}

function var_array_empty (&$state, $stack_frame, $variable)
{
  if (! isset ($state ['vars']))
    return TRUE;

  if (! isset ($state ['vars'] [$stack_frame]))
    return TRUE;

  if (! isset ($state ['vars'] [$stack_frame] [$variable]))
    return TRUE;

  if (var_array_max_index ($state ['vars'] [$stack_frame] [$variable]) < 0)
    return TRUE;

  return FALSE;
}

function var_array_rowcount (&$state, $stack_frame, $variable, $columncount)
{
  if (! isset ($state ['vars']))
    return 0;

  if (! isset ($state ['vars'] [$stack_frame]))
    return 0;

  if (! isset ($state ['vars'] [$stack_frame] [$variable]))
    return 0;
  
  return (1 + floor (var_array_max_index ($state ['vars'] [$stack_frame] [$variable]) / $columncount));
}

function var_array_element_read (&$state, $stack_frame, $variable, $columncount, $row, $col)
{
  if (! isset ($state ['vars']))
    return NULL;

  if (! isset ($state ['vars'] [$stack_frame]))
    return NULL;

  if (! isset ($state ['vars'] [$stack_frame] [$variable]))
    return NULL;

  if (! isset ($state ['vars'] [$stack_frame] [$variable] [$row * $columncount + $col]))
    return NULL;

  return $state ['vars'] [$stack_frame] [$variable] [$row * $columncount + $col];
}

function var_array_element_write (&$state, $stack_frame, $variable, $columncount, $row, $col, $value)
{
  $state ['vars'] [$stack_frame] [$variable] [$row * $columncount + $col] = $value;
}

function var_array_deleterow (&$state, $stack_frame, $variable, $columncount, $row)
{
  if (! isset ($state ['vars']))
    return;

  if (! isset ($state ['vars'] [$stack_frame]))
    return;

  if (! isset ($state ['vars'] [$stack_frame] [$variable]))
    return;

  # We have to be careful with the array_splice function, since it depends on
  # the array elements having been assigned sequentially. The compiler always
  # assigns array elements sequentially, so we can use it here safely.

  array_splice ($state ['vars'] [$stack_frame] [$variable], ($row * $columncount), $columncount);
}

function var_stack_maxindex (&$state)
{
  if (! isset ($state ['vars']))
    return 0;

  $maxindex = var_array_max_index ($state ['vars']);
  return (($maxindex < 0) ? 0 : $maxindex);
}

function var_stack_truncate (&$state, $stack_frame)
{
  if (! isset ($state ['vars']))
    return;

  if (! is_array ($state ['vars']))
    return;

  if (count ($state ['vars']) == 0)
    return;

  # We'd like to do this:
  # 
  #   array_splice ($state ['vars'],  $stack_frame + 1);
  # 
  # except that the array keys might be out of order and it
  # would do the wrong thing. Do it the hard way instead: 

  for ($i = $stack_frame + 1; $i <= max (array_keys ($state ['vars'])); $i++)
    {
      unset ($state ['vars'] [$i]);
    }

}

function subroutine_push (&$state, $subroutine_id, $return_location, $argument_array)
{
  $next_stack_frame = var_stack_maxindex ($state) + 1;

  var_scalar_write ($state, $next_stack_frame, 0, $subroutine_id);
  var_scalar_write ($state, $next_stack_frame, 1, $return_location);
  var_scalar_write ($state, $next_stack_frame, 2, NULL);

  $nextindex = 3;
  foreach ($argument_array as $arg)
    {
      var_scalar_write ($state, $next_stack_frame, $nextindex, $arg);
      $nextindex ++;
    }
}

function subroutine_pop (&$state)
{
  if (! isset ($state ['vars']))
    return;

  if (! is_array ($state ['vars']))
    return;

  if (count ($state ['vars']) == 0)
    return;

  # We'd like to do this:
  # 
  #   array_pop ($state ['vars']);
  # 
  # except that the array keys might be out of order and it
  # would do the wrong thing. Do it the hard way instead: 

  unset ($state ['vars'] [max (array_keys ($state ['vars']))]);
}

function display_state_update (&$state, $display_state)
{
  $state ['display_state'] = $display_state;
  $state ['creation_time'] = gen_timestamp ();
  $state ['cid']           = gen_cid ();
  $state ['auth_token']    = gen_auth_token ();
  $state ['next_cid']      = NULL;
}
