;;;----------------------------------------------------------------------
;;; Eleven compiler - intermediate code file pretty printer.
;;; 
;;; Copyright (C) 2004 Joseph Morrison <jdm@statesafe.org>.
;;; 
;;; This program is free software; you can redistribute it and/or modify it under
;;; the terms of the GNU General Public License as published by the Free Software
;;; Foundation; either version 2 of the License, or (at your option) any later
;;; version.
;;; 
;;; This program is distributed in the hope that it will be useful, but WITHOUT
;;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
;;; FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
;;; details. Visit http://www.gnu.org/copyleft/gpl.html for the full text of the
;;; license, or you can request a copy from the Free Software Foundation, Inc.,
;;; 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;;; 
;;; This license allows you to use the Eleven compiler no charge under the
;;; condition that if you create a derived work (either based on the Eleven
;;; compiler or based on code generated by the Eleven compiler) and redistribute
;;; it, the complete source code for your application must be available and freely
;;; redistributable.  A commercial license for Eleven is available without this
;;; condition. For more information please email info@statesafe.org.
;;;----------------------------------------------------------------------

;;; This is intended to be used by the dump11-intermediate program for
;;; displaying intermediate files generated by the Eleven compiler.
;;; See the dump11-intermediate documentation for more information.

(use-modules (ice-9 pretty-print))

;;; Verify that there is one command line argument (in addition to the
;;; name of this program). Take that as an input filename. Read the
;;; file and pretty-print it.

(if (not (= (length (command-line)) 2))
    (begin
      (display "internal error")
      (newline)
      (exit 1)))
  
(define input-file (list-ref (command-line) 1))

(pretty-print (with-input-from-file input-file read))
